#ifndef _EXTERNALFUNC_H_
#define _EXTERNALFUNC_H_

#if BUILDING_DLL
# define DLLIMPORT __declspec (dllexport)
#else /* Not BUILDING_DLL */
# define DLLIMPORT __declspec (dllimport)
#endif /* Not BUILDING_DLL */

#define MAX_D 1000       //Maxmo mmero de dimensiones soportadas por vector
#define MAX_STR_LEN 4000
#define MAX_LOB_LEN 15000

DLLIMPORT double vecsum(char* str, short str_ind, int str_len, short *ret_ind); 

DLLIMPORT char* vecSum2(char* str1,      short str1_ind, int str1_len, 
                        char* str2,      short str2_ind, int str2_len,
                        short* ret_ind,  int*   ret_len, int*   ret_maxlen);

DLLIMPORT char* vecProdScalar(char*   str1,   short str1_ind, int str1_len, 
                              double* val,    short val_ind, 
                              short* ret_ind, int*  ret_len,  int* ret_maxlen);

DLLIMPORT double dotProduct(char* str1, short str1_ind, int str1_len, 
                            char* str2, short str2_ind, int str2_len, short *ret_ind);

DLLIMPORT double dotProduct2(char* str1, short str1_ind, int str1_len, 
                             char* str2, short str2_ind, int str2_len, short *ret_ind);

DLLIMPORT double euclidianDist(char* str1, short str1_ind, int str1_len, 
                               char* str2, short str2_ind, int str2_len, short *ret_ind);

DLLIMPORT int argmin(char* str, short str_ind, int str_len, short *ret_ind); 

DLLIMPORT int argmax(char* str, short str_ind, int str_len, short *ret_ind);

/*Internal Functions NOT DLLIMPORT*/
void split(char* str, double* arr, int* size);
void join(double* arr, int* size, char* str);

#endif /* _EXTERNALFUNC_H_ */
